﻿# Script that can be used as a pre-build event in order to get the "Version" attribute of an EXE and store it in a property. We can further use this property
# to write the version value in the registries.

# As a prerequisite, please create the proeprties in your project with empty values (in order to create a property with an empty value, simply add a comment to it).

Add-Type -AssemblyName PresentationFramework

$AICom = "C:\Program Files (x86)\Caphyon\Advanced Installer 16.3\bin\x86\AdvancedInstaller.com"
$projectPath = "C:\Users\Catalin\Desktop\Retrieve version from multiple EXEs.aip"
$repackagerPath = "C:\Program Files (x86)\Caphyon\Advanced Installer 16.3\bin\x86\RepackagerCLI.exe"
$updaterPath = "C:\Program Files (x86)\Caphyon\Advanced Installer 16.3\bin\x86\updater.exe"

# get the version from the Repackager and store it in a variable
# the below cmdlet will return a string, which will look something like this: 1, 0, 0, 0. We will further use the "Replace()" method to replace the "," with "."
$repackagerVer = (get-item -path $repackagerPath).VersionInfo.FileVersion.Replace(',','.')
[System.Windows.MessageBox]::Show($repackagerVer)
$updaterVer = (get-item -path $updaterPath).VersionInfo.FileVersion.Replace(',','.')
[System.Windows.MessageBox]::Show($updaterVer)

# now that we have got the version of the EXEs, we will further set the properties that we created in our project.

Start-Process -FilePath $AICom -ArgumentList "/edit `"$projectPath`" /SetProperty REPACKAGER_VERSION=`"$repackagerVer`""
Start-Sleep -Seconds 2
Start-Process -FilePath $AICom -ArgumentList "/edit `"$projectPath`" /SetProperty UPDATER_VERSION=`"$updaterVer`""
Start-Sleep -Seconds 2
Start-Process -FilePath $AICom -ArgumentList "/save"